[Libguestfs] [nbdkit PATCH 3/5] tests: Test retry when get_size values change

Eric Blake eblake at redhat.com
Fri Oct 4 02:54:38 UTC 2019


Someday, we want to enhance the NBD protocol to support resizes.  But
until then, it's worth testing that we don't crash if a reopen happens
to result in a smaller image.

Signed-off-by: Eric Blake <eblake at redhat.com>
---
 tests/Makefile.am        |   2 +
 tests/test-retry-size.sh | 101 +++++++++++++++++++++++++++++++++++++++
 2 files changed, 103 insertions(+)
 create mode 100755 tests/test-retry-size.sh

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 9d95d567..558ea86f 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -121,6 +121,7 @@ EXTRA_DIST = \
 	test-readahead-copy.sh \
 	test-retry.sh \
 	test-retry-extents.sh \
+	test-retry-size.sh \
 	test-retry-readonly.sh \
 	test-retry-reopen-fail.sh \
 	test-retry-zero-flags.sh \
@@ -1062,6 +1063,7 @@ TESTS += \
 	test-retry.sh \
 	test-retry-readonly.sh \
 	test-retry-extents.sh \
+	test-retry-size.sh \
 	test-retry-reopen-fail.sh \
 	test-retry-zero-flags.sh \
 	$(NULL)
diff --git a/tests/test-retry-size.sh b/tests/test-retry-size.sh
new file mode 100755
index 00000000..eed7aef1
--- /dev/null
+++ b/tests/test-retry-size.sh
@@ -0,0 +1,101 @@
+#!/usr/bin/env bash
+# nbdkit
+# Copyright (C) 2018-2019 Red Hat Inc.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are
+# met:
+#
+# * Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# * Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# * Neither the name of Red Hat nor the names of its contributors may be
+# used to endorse or promote products derived from this software without
+# specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
+# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+source ./functions.sh
+set -e
+set -x
+
+requires qemu-io --version
+
+files="retry-size-open-count"
+rm -f $files
+cleanup_fn rm -f $files
+
+touch retry-size-open-count
+start_t=$SECONDS
+
+# Create a custom plugin which will test retrying.
+st=0
+nbdkit -v -U - \
+       sh - \
+       --filter=retry retry-delay=1 \
+       --run 'qemu-io -f raw -r $nbd \
+    -c "r 512 512" -c "r 0 512"' <<'EOF' || st=$?
+#!/usr/bin/env bash
+case "$1" in
+    open)
+        # Count how many times the connection is (re-)opened.
+        read i < retry-size-open-count
+        echo $((i+1)) > retry-size-open-count
+        ;;
+    get_size)
+        # Start big, then clamp down to reflect unreadable sector
+        read i < retry-size-open-count
+        if [ $i = 1 ]; then
+            echo 1024
+        else
+            echo 512
+        fi
+        ;;
+    pread)
+        # Fail for anything beyond 512
+        if [ $(( $3 + $4 )) -gt 512 ]; then
+            echo "EINVAL too far into file" >&2
+            exit 1
+        fi
+        dd if=/dev/zero count=$3 iflag=count_bytes
+        ;;
+    *) exit 2 ;;
+esac
+EOF
+
+# In this test we should see the following:
+# open reports size 1024
+# first pread FAILS
+# retry and wait 1 seconds
+# open reports size 512
+# first pread FAILS immediately for being out of bounds
+# second pread succeeds
+
+# The minimum time for the test should be 1 = 1 second.
+end_t=$SECONDS
+if [ $((end_t - start_t)) -lt 1 ]; then
+    echo "$0: test ran too quickly"
+    exit 1
+fi
+
+# Check the handle was opened 2 times (first open + one reopen).
+read open_count < retry-size-open-count
+if [ $open_count -ne 2 ]; then
+    echo "$0: open-count ($open_count) != 2"
+    exit 1
+fi
-- 
2.21.0




More information about the Libguestfs mailing list